#============================================================================================================================================#
# -*- coding:Utf-8 -*-
# admin_connect V1.2p (20/01/2008)
# MATTIE'S EVENTSCRIPTS 2.0, PYTHON OPERATIONNEL




import es, os, psyco, keyvalues as _key, playerlib as _use
psyco.full()

ac_info = es.AddonInfo()
ac_info.version = "1.2p"
ac_info.author = "DoCky"
ac_info.name = "admin_connect"
ac_info.url = "http://addons.eventscripts.com/addons/user/11751"
ac_path = os.getcwd().replace(os.sep, "/") + "/cstrike/cfg/admin_connect/"





#    SYSTEM    #
class System:
    """
        Script system
    """

    _tell = es.ServerVar("ac_advert")
    _time = es.ServerVar("ac_msgtps")
    _admm = es.ServerVar("ac_msgadm")
    _adms = es.ServerVar("ac_sndadm")
    _down = es.ServerVar("ac_dlfile")

    _admi = None
    _name = _key.KeyValues(name="ac_admin")


    @staticmethod
    def loadConf():
        if not os.path.isfile(ac_path + "config.cfg"):
            es.log("[admin_connect] missing file : cfg/admin_connect/config.cfg")

        else:
            es.ForceServerCommand("es_mexec ../cfg/admin_connect/config.cfg")
            es.log("[admin_connect] config file loaded")

            es.ServerVar(ac_info.name, ac_info.version, "version actuelle du script").makepublic()


    @staticmethod
    def keyGroup():
        if not os.path.isfile(ac_path + "ac_admin.txt"):
            es.log("[admin_connect] missing file : cfg/admin_connect/ac_admin")

            System._name.save("cfg/admin_connect/ac_admin.txt")
            es.log("[admin_connect] file created : you must edit it")

        else:
            System._name.load("cfg/admin_connect/ac_admin.txt")
            System._admi = System._name.keys()
            es.log("[admin_connect] admin list loaded")

            if not len(System._admi):
                es.log("[admin_connect] no admin registered")


    @staticmethod
    def downFile():
        if int(System._down):
            for user in System._admi:

                path = System._name[user]["sonc"]
                if path:
                    es.stringtable("downloadables", "sound/" + path)

                path = System._name[user]["sond"]
                if path:
                    es.stringtable("downloadables", "sound/" + path)




#    SCRIPT    #
def load():
    System.loadConf()
    System.keyGroup()
    System.downFile()


def es_map_start(event_var):
    System.loadConf()
    System.keyGroup()
    System.downFile()


def player_changename(event_var):
    System._name[es.getplayersteamid(event_var["userid"])]["name"] = event_var["newname"]


def es_player_validated(event_var):
    if str(event_var["networkid"]) in System._admi:
        System._name[event_var["networkid"]]["name"] = event_var["name"]

        tell = System._name[event_var["networkid"]]["msgc"] % event_var["name"]
        if tell:

            if int(System._admm):
                for unid in System._admi:
                    user = es.getuserid(unid)

                    if es.getuserid(user):
                        mode = System._tell

                        if mode == "msg" or mode == "all":
                            es.tell(user, "#multi", tell)

                        if mode == "men" or mode == "all":
                            es.menu(System._time, user, tell)

            else:
                mode = System._tell

                if mode == "msg" or mode == "all":
                    es.msg("#multi", tell)

                if mode == "men" or mode == "all":
                    for user in _use.getUseridList("#human"):
                        es.menu(System._time, user, tell)


def player_activate(event_var):
    if str(event_var["es_steamid"]) in System._admi:
        path = System._name[event_var["es_steamid"]]["sonc"]

        if path:
            if int(System._adms):

                for unid in System._admi:
                    user = es.getuserid(unid)

                    if es.getuserid(user):
                        es.playsound(user, path, 1)

            else:
                for user in _use.getUseridList("#human"):
                    es.playsound(user, path, 1)


def player_disconnect(event_var):
    if str(event_var["networkid"]) in System._admi:
        tell = System._name[event_var["networkid"]]["msgd"] % System._name[event_var["networkid"]]["name"]
        path = System._name[event_var["networkid"]]["sonc"]

        if tell:
            if int(System._admm):

                for unid in System._admi:
                    user = es.getuserid(unid)

                    if es.getuserid(user):
                        mode = System._tell

                        if mode == "msg" or mode == "all":
                            es.tell(user, "#multi", tell)

                        if mode == "men" or mode == "all":
                            es.menu(System._time, user, tell)

            else:
                mode = System._tell

                if mode == "msg" or mode == "all":
                    es.msg("#multi", tell)

                if mode == "men" or mode == "all":
                    for user in _use.getUseridList("#human"):
                        es.menu(System._time, user, tell)

        if path:
            if int(System._adms):

                for unid in System._admi:
                    user = es.getuserid(unid)

                    if es.getuserid(user):
                        es.playsound(user, path, 1)

            else:
                for user in _use.getUseridList("#human"):
                    es.playsound(user, path, 1)

#============================================================================================================================================#
